//zelovoc
#include<cstdio>
#include<vector>
#include<iostream>
#include<algorithm>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<cstring>
#include<cmath>

using namespace std;
#define For(i,n) for(int i = 0; i<int(n); ++i)
#define INF 1023456789
#define LINF 1023456789123456789LL

typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<int> vint;

#define db(x) cerr << #x << " = " << x << endl

#define mod 12345647ll

int main()
{
	string s;
	while(1)
	{
		getline(cin, s);
		vint N, L;
		int p;
		for(p=0; s[p] != ' '; p++)N.push_back(s[p] - '0');
		for(p++; p < (int)s.size(); p++)L.push_back(s[p] - '0');
		if(N == vint(1, 0))break;
		int n = N.size();
		int dd = n - L.size();
		L.resize(n);
		for(int i=n-1; i>=dd; i--)
		{
			L[i] = L[i-dd];
		}
		for(int i=0; i<dd; i++)L[i] = 0;
		
		vector<vector<vector<ll> > > dp(n+1, vector<vector<ll> > (3, vector<ll> (8, 0)));
		dp[0][0][7] = 1;
		for(int read = 0; read < n; read++)
		{
			for(int c1 = 0; c1 < 10; c1++)
			{
				if(c1 == 3)continue;
				for(int c2 = 0; c2 < 10; c2++)
				{
					if(c2 == 3)continue;
					for(int c3 = 0; c3 < 10; c3++)
					{
						if(c3 == 3)continue;
						int s = c1 + c2 + c3;
						int zvpred = -1, zvpo = -1;
						for(int i=0; i<3; i++)
						{
							for(int j=0; j<3; j++)
							{
								if(s+j == N[read] + i*10)
								{
									zvpred = i;
									zvpo = j;
								}
							}
						}
						if(zvpred == -1)continue;
						int klesa = 0, rovne = 0;
						if(c1 < L[read])klesa |= 1;
						if(c1 == L[read])rovne |= 1;
						if(c2 < L[read])klesa |= 2;
						if(c2 == L[read])rovne |= 2;
						if(c3 < L[read])klesa |= 4;
						if(c3 == L[read])rovne |= 4;
						for(int mask = 0; mask < 8; mask++)
						{
							if(mask & klesa)continue;
							dp[read+1][zvpo][mask & rovne] = (dp[read+1][zvpo][mask & rovne] + dp[read][zvpred][mask])% mod;
						}
					}
				}
			}
		}
		ll res = 0;
		for(int i=0; i<8; i++)
		{
			res += dp[n][0][i];
			res %= mod;
		}
		printf("%lld\n", res);
		
	}
	return 0;
}
