//zelovoc
#include<cstdio>
#include<vector>
#include<iostream>
#include<algorithm>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<cstring>
#include<cmath>

using namespace std;
#define For(i,n) for(int i = 0; i<int(n); ++i)
#define INF 1023456789
#define linf 1023456789123456789LL

typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<int> vint;

#define db(x) //cerr << #x << " = " << x << endl

int main() 
{
	int t, n, start, ciel;
	while(scanf("%d %d %d %d",&t, &n, &start, &ciel) > 0)
	{
		if(t == 0 && n == 0 && start == 0 && ciel == 0)break;
		db(t);
		db(n);
		db(start);
		db(ciel);
		start--;
		ciel--;
		vector<ll> dist(n, linf);
		dist[start] = 0;
		vector<int> fr(t), to(t);
		vector<ll> d(t);
		vector<vector<int> > sus(n);
		for(int i=0; i<t; i++)
		{
			double p;
			scanf("%d %d %lf",&fr[i],&to[i],&p);
			d[i] = p * -1000;
			db(p);
			fr[i]--;
			to[i]--;
			sus[fr[i]].push_back(i);
		}
		
		queue<int> fronta;
		for(int i=0; i<n; i++)
		{
			for(int j=0; j<t; j++)
			{
				if(dist[fr[j]] == linf)continue;
				if(dist[to[j]] > dist[fr[j]] + d[j])
				{
					dist[to[j]] = dist[fr[j]] + d[j];
				}
			}
		}
		vector<bool> bol_som(n, 0);
		for(int j=0; j<t; j++)
		{
			if(dist[fr[j]] == linf)continue;
			if(dist[to[j]] > dist[fr[j]] + d[j])
			{
				fronta.push(to[j]);
				bol_som[to[j]] = 1;
			}
		}
		while(!fronta.empty())
		{
			int cur = fronta.front();
			fronta.pop();
			for(int i=0; i<sus[cur].size(); i++)
			{
				int on = to[sus[cur][i]];
				if(!bol_som[on])
				{
					fronta.push(on);
					bol_som[on] = 1;
				}
			}
		}
		if(bol_som[ciel])printf("TRUE\n");
		else printf("FALSE\n");
	}
	return 0;
}
