//zelovoc
#include<cstdio>
#include<vector>
#include<iostream>
#include<algorithm>
#include<map>
#include<set>
#include<queue>
#include<stack>
#include<cstring>
#include<cmath>

using namespace std;
#define For(i,n) for(int i = 0; i<int(n); ++i)
#define INF 1023456789
#define LINF 1023456789123456789LL

typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;
typedef vector<int> vint;

#define db(x) cerr << #x << " = " << x << endl

int main() {
	int n;
	cin >> n;
	while (n!=0) {
		int A[n];
		for (int i=0; i<n; i++) {
			cin >> A[i];
		}
		vector<int> D[n];
		vector<int> H[n];
		for (int i=0; i<n; i++) {
			int val=i-A[i];
			if (val>=0) {
				for (int j=0; j<(int)D[val].size(); j++) {
					int kam=D[val][j];
					H[i].push_back(kam);
					H[kam].push_back(i);
				}
			}
			int wol=i+A[i];
			if (wol<n) {
				D[wol].push_back(i);
			}
		}
		bool bol[n];
		for (int i=0; i<n; i++) {
			bol[i]=false;
		}
		queue<int> Q;
		Q.push(0);
		bol[0]=true;
		while (!Q.empty()) {
			int kde=Q.front();
			Q.pop();
			for (int i=0; i<(int)H[kde].size(); i++) {
				int kam=H[kde][i];
				if (bol[kam]) continue;
				bol[kam]=true;
				Q.push(kam);
			}
		}
		int ans=n-1;
		while (!bol[ans]) {
			ans--;
		}
		cout << ans << "\n";
		
		cin >> n;
	}
	return 0;
}
